within Sankey.Examples;
model BatteryCharging
    extends .Electrification.Examples.BatteryCharging;
    .Sankey.Node node(label = "Charger") annotation(Placement(transformation(extent = {{-70.0,60.0},{-50.0,80.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link(label = "Battery In",value = battery.summary.p_in,integrate = true) annotation(Placement(transformation(extent = {{-40.0,60.0},{-20.0,80.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node2(id = 2,label = "Battery") annotation(Placement(transformation(extent = {{-10.0,60.0},{10.0,80.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link2(label = "Charger Losses",value = charger.summary.p_loss,integrate = true) annotation(Placement(transformation(extent = {{20.0,30.225847095238805},{40.0,49.774152904761195}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node4(id = 3,label = "Losses") annotation(Placement(transformation(extent = {{50.0,40.0},{70.0,60.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link1(label = "Battery Losses",integrate = true,value = battery.summary.p_loss) annotation(Placement(transformation(extent = {{20.0,50.0},{40.0,70.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node3(label = "Battery charge gain",id = 4) annotation(Placement(transformation(extent = {{50.0,70.0},{70.0,90.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link3(value = link.value - link1.value,integrate = true,label = "Battery charge gain") annotation(Placement(transformation(extent = {{20.0,70.0},{40.0,90.0}},origin = {0.0,0.0},rotation = 0.0)));
equation
    connect(node.sankeyPort,link.source) annotation(Line(points = {{-60,70},{-40,70}},color = {0,0,0}));
    connect(link.target,node2.sankeyPort) annotation(Line(points = {{-20,70},{0,70}},color = {0,0,0}));
    connect(node2.sankeyPort,link1.source) annotation(Line(points = {{0,70},{14,70},{14,60},{20,60}},color = {0,0,0}));
    connect(link1.target,node4.sankeyPort) annotation(Line(points = {{40,60},{50,60},{50,50},{60,50}},color = {0,0,0}));
    connect(link2.target,node4.sankeyPort) annotation(Line(points = {{40,40},{50,40},{50,50},{60,50}},color = {0,0,0}));
    connect(link2.source,node.sankeyPort) annotation(Line(points = {{20,40},{-50,40},{-50,70},{-60,70}},color = {0,0,0}));
    connect(link3.source,node2.sankeyPort) annotation(Line(points = {{20,80},{0,80},{0,70}},color = {0,0,0}));
    connect(link3.target,node3.sankeyPort) annotation(Line(points = {{40,80},{60,80}},color = {0,0,0}));
end BatteryCharging;
