within Sankey.Examples;
model MicroGrid
    extends .Electrification.Examples.MicroGrid;
    .Sankey.Node node(label = "grid") annotation(Placement(transformation(extent = {{-106.0,-126.0},{-86.0,-106.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node2(label = "solar",id = 2) annotation(Placement(transformation(extent = {{-106.0,-186.0},{-86.0,-166.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node3(label = "battery",id = 4) annotation(Placement(transformation(extent = {{-36.0,-204.0},{-16.0,-184.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node4(id = 7,label = "consumers") annotation(Placement(transformation(extent = {{78.0,-166.0},{98.0,-146.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node6(label = "inverter",id = 6) annotation(Placement(transformation(extent = {{24.0,-206.0},{44.0,-186.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link(label = "solar->battery",value = max(battery.summary.p_in,0),integrate = true) annotation(Placement(transformation(extent = {{-80.0,-194.0},{-60.0,-174.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link2(label = "grid",value = grid.summary.p_out,integrate = true) annotation(Placement(transformation(extent = {{-82.0,-126.0},{-62.0,-106.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link4(label = "battery->inverter",value = max(battery.summary.p_out,0),integrate = true) annotation(Placement(transformation(extent = {{-8.0,-204.0},{12.0,-184.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link5(label = "solar->inverter",value = inverter.summary.p_in_dc - link4.value,integrate = true) annotation(Placement(transformation(extent = {{-34.0,-176.0},{-14.0,-156.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node5(label = "battery losses",id = 5) annotation(Placement(transformation(extent = {{8.0,-242.0},{28.0,-222.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node7(label = "inverter losses",id = 8) annotation(Placement(transformation(extent = {{80.0,-240.0},{100.0,-220.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link3(value = inverter.summary.p_out_ac,label = "inverter->consumer",integrate = true) annotation(Placement(transformation(extent = {{50,-188},{70,-168}},origin = {0,0},rotation = 0)));
    .Sankey.Link link6(value = battery.summary.p_loss,label = "battery losses",integrate = true) annotation(Placement(transformation(extent = {{-14.0,-242.0},{6.0,-222.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link7(label = "inverter losses",value = inverter.summary.p_loss,integrate = true) annotation(Placement(transformation(extent = {{58.0,-242.0},{78.0,-222.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node8(label = "grid losses",id = 3) annotation(Placement(transformation(extent = {{-50.0,-150.0},{-30.0,-130.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link8(value = grid.summary.p_loss,label = "grid losses",integrate = true) annotation(Placement(transformation(extent = {{-80.0,-148.0},{-60.0,-128.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Node node9(id = 9,label = "battery charge gain") annotation(Placement(transformation(extent = {{10.0,-272.0},{30.0,-252.0}},origin = {0.0,0.0},rotation = 0.0)));
    .Sankey.Link link9(integrate = true,label = "battery charge gain",value = link.value - link4.value) annotation(Placement(transformation(extent = {{-14.0,-272.0},{6.0,-252.0}},origin = {0.0,0.0},rotation = 0.0)));
equation
    connect(node.sankeyPort,link2.source) annotation(Line(points = {{-96,-116},{-82,-116}},color = {0,0,0}));
    connect(link.source,node2.sankeyPort) annotation(Line(points = {{-80,-184},{-80,-176},{-96,-176}},color = {0,0,0}));
    connect(link.target,node3.sankeyPort) annotation(Line(points = {{-60,-184},{-48,-184},{-48,-194},{-26,-194}},color = {0,0,0}));
    connect(link2.target,node4.sankeyPort) annotation(Line(points = {{-62,-116},{4,-116},{4,-156},{88,-156}},color = {0,0,0}));
    connect(node3.sankeyPort,link4.source) annotation(Line(points = {{-26,-194},{-8,-194}},color = {0,0,0}));
    connect(link4.target,node6.sankeyPort) annotation(Line(points = {{12,-194},{34,-194},{34,-196}},color = {0,0,0}));
    connect(node2.sankeyPort,link5.source) annotation(Line(points = {{-96,-176},{-80,-176},{-80,-166},{-34,-166}},color = {0,0,0}));
    connect(link5.target,node6.sankeyPort) annotation(Line(points = {{-14,-166},{34,-166},{34,-196}},color = {0,0,0}));
    connect(node6.sankeyPort,link3.source) annotation(Line(points = {{34,-196},{34,-178},{50,-178}},color = {0,0,0}));
    connect(link3.target,node4.sankeyPort) annotation(Line(points = {{70,-178},{74,-178},{74,-156},{88,-156}},color = {0,0,0}));
    connect(node6.sankeyPort,link7.source) annotation(Line(points = {{34,-196},{34,-190},{52,-190},{52,-232},{58,-232}},color = {0,0,0}));
    connect(link7.target,node7.sankeyPort) annotation(Line(points = {{78,-232},{84,-232},{84,-224},{90,-224},{90,-230}},color = {0,0,0}));
    connect(node3.sankeyPort,link6.source) annotation(Line(points = {{-26,-194},{-26,-232},{-14,-232}},color = {0,0,0}));
    connect(link6.target,node5.sankeyPort) annotation(Line(points = {{6,-232},{12,-232},{12,-226},{18,-226},{18,-232}},color = {0,0,0}));
    connect(node.sankeyPort,link8.source) annotation(Line(points = {{-96,-116},{-88,-116},{-88,-138},{-80,-138}},color = {0,0,0}));
    connect(link8.target,node8.sankeyPort) annotation(Line(points = {{-60,-138},{-54,-138},{-54,-134},{-40,-134},{-40,-140}},color = {0,0,0}));
    connect(link9.target,node9.sankeyPort) annotation(Line(points = {{6,-262},{20,-262}},color = {0,0,0}));
    connect(link9.source,node3.sankeyPort) annotation(Line(points = {{-14,-262},{-26,-262},{-26,-194}},color = {0,0,0}));
end MicroGrid;
