within Sankey;
model Link
  Base.SankeyPort target "Connect to target node" annotation (Placement(transformation(extent={{90,-10},{
            110,10}}),  iconTransformation(extent={{90,-10},{110,10}})));
  Base.SankeyPort source "Connect to source node" annotation (Placement(
        transformation(extent={{-110,-10},{-90,10}}), iconTransformation(
          extent={{-110,-10},{-90,10}})));
  input Real value "Value of transferred quantity" annotation (Dialog(group="Input"));
  parameter String label = "" "Label of link: __Link__";
    parameter Boolean integrate = false "Integrate value to get flow quantity" annotation(Dialog(group = "Input"));

equation
  target.value = -value;
  source.value = value;

  annotation (Icon(coordinateSystem(preserveAspectRatio=false), graphics={
          Polygon(
          points={{-90,20},{60,20},{60,26},{90,0},{60,-26},{60,-20},{-90,-20},{-90,
              20}},
          lineColor={0,0,0},
          fillColor={85,170,255},
          fillPattern=FillPattern.Solid),
        Text(
          extent={{-60,20},{60,-20}},
          lineColor={0,0,0},
          fillColor={85,170,255},
          fillPattern=FillPattern.Solid,
          textString="%value"),
        Text(
          extent={{-40,-26},{40,-46}},
          lineColor={0,0,0},
          fillColor={85,170,255},
          fillPattern=FillPattern.Solid,
          textString="%label")}),                                Diagram(
        coordinateSystem(preserveAspectRatio=false), graphics={Text(
          extent={{-40,-24},{40,-44}},
          lineColor={0,0,0},
          fillColor={85,170,255},
          fillPattern=FillPattern.Solid,
          textString="%label")}));
end Link;
